 #include <math.h>
/*
	* m						- rows 
	* n						- columns
	* 	X					-matrix (mxn) of points , m - number of points n- number of dimensions
	* 	x					-points for wich to callculate the correlation (txn)
	* 	t					- number of points
	*
	* Corr			- correlation vector (m).
	* Theta		- range parameters (n).
	* Output is (mxt)
	*
	* Called form corrVectorData.sci;
	*
	* To access X(i,j)  (mxn)  use X[i+j*m]   !!!!
	*
	*
	*
	* *Scilab code:
	*
	*
	*								for i=1:t 
															for k=1:model.m
																							kx(k,i)=funct(S(k,:)-x(i,:),model.theta);
															end;
										end;


										for i=1:model.m
													kx(i)=funct(S(i,:)-x,model.theta);
										end;

	*
	*
	*/
#include "corr_functions.h"
    double corr_vector(double *X, double *Theta,int *m, int *n,double *x,int *t, int *fun, double *Corr)
    {
									int i,j,k;
										double tmp;
										/*if (*fun==1) {
															for ( i=0; i<*m; i++)
															{
																									Corr[i]=1;
																									for ( j=0; j<*n; j++)
																									{
																														Corr[i]=Corr[i]*gaussian(X[i+j**m]-x[j],Theta[j]);// callculates gaussian covariance
																													
																									}
																//Corr[i]=j;
															}
										}
										*/
//gaussian
									if (*fun==1) {
															for ( i=0; i<*t; i++)
															{
																				for (k=0; k<*m;k++)
																				{
																									Corr[k+i**m]=1;
																									for ( j=0; j<*n; j++)
																									{
																														Corr[k+i**m]=Corr[k+i**m]*gaussian(X[k+j**m]-x[i+j**t],Theta[j]);// callculates gaussian covariance
																													//	Corr[k+i**m]=3;
																									}
																				}
															}
									}
	// matern
					if (*fun==2) {
										for ( i=0; i<*t; i++)
															{
																				for (k=0; k<*m;k++)
																				{
																									Corr[k+i**m]=1;
																									for ( j=0; j<*n; j++)
																									{
																														tmp=X[k+j**m]-x[i+j**t];
																														if (tmp <0) { tmp=-tmp;} 
																														Corr[k+i**m]=Corr[k+i**m]*matern_5_2(tmp,Theta[j]);
																														
																													//	Corr[k+i**m]=3;
																									}
																				}
															}
															
					}
										
				}
